=head1 NAME

ffplay - FFplay media player

=head1 SYNOPSIS

ffplay [options] F<input_file>

=head1 DESCRIPTION


FFplay is a very simple and portable media player using the FFmpeg
libraries and the SDL library. It is mostly used as a testbed for the
various FFmpeg APIs.

=head1 OPTIONS


All the numerical options, if not specified otherwise, accept in input
a string representing a number, which may contain one of the
International System number postfixes, for example 'K', 'M', 'G'.
If 'i' is appended after the postfix, powers of 2 are used instead of
powers of 10. The 'B' postfix multiplies the value for 8, and can be
appended after another postfix or used alone. This allows using for
example 'KB', 'MiB', 'G' and 'B' as postfix.

Options which do not take arguments are boolean options, and set the
corresponding value to true. They can be set to false by prefixing
with "no" the option name, for example using "-nofoo" in the
commandline will set to false the boolean option with name "foo".


=head2 Generic options


These options are shared amongst the ff* tools.


=over 4



=item B<-L>

Show license.


=item B<-h, -?, -help, --help>

Show help.


=item B<-version>

Show version.


=item B<-formats>

Show available formats.

The fields preceding the format names have the following meanings:

=over 4


=item B<D>

Decoding available

=item B<E>

Encoding available

=back



=item B<-codecs>

Show available codecs.

The fields preceding the codec names have the following meanings:

=over 4


=item B<D>

Decoding available

=item B<E>

Encoding available

=item B<V/A/S>

Video/audio/subtitle codec

=item B<S>

Codec supports slices

=item B<D>

Codec supports direct rendering

=item B<T>

Codec can handle input truncated at random locations instead of only at frame boundaries

=back



=item B<-bsfs>

Show available bitstream filters.


=item B<-protocols>

Show available protocols.


=item B<-filters>

Show available libavfilter filters.


=item B<-pix_fmts>

Show available pixel formats.


=item B<-loglevel> I<loglevel>

Set the logging level used by the library.
I<loglevel> is a number or a string containing one of the following values:

=over 4


=item B<quiet>


=item B<panic>


=item B<fatal>


=item B<error>


=item B<warning>


=item B<info>


=item B<verbose>


=item B<debug>


=back


By default the program logs to stderr, if coloring is supported by the
terminal, colors are used to mark errors and warnings. Log coloring
can be disabled setting the environment variable B<NO_COLOR>.


=back



=head2 Main options



=over 4


=item B<-x> I<width>

Force displayed width.

=item B<-y> I<height>

Force displayed height.

=item B<-s> I<size>

Set frame size (WxH or abbreviation), needed for videos which don't
contain a header with the frame size like raw YUV.

=item B<-an>

Disable audio.

=item B<-vn>

Disable video.

=item B<-ss> I<pos>

Seek to a given position in seconds.

=item B<-t> I<duration>

play E<lt>durationE<gt> seconds of audio/video

=item B<-bytes>

Seek by bytes.

=item B<-nodisp>

Disable graphical display.

=item B<-f> I<fmt>

Force format.

=item B<-window_title> I<title>

Set window title (default is the input filename).

=item B<-loop> I<number>

Loops movie playback E<lt>numberE<gt> times. 0 means forever.

=item B<-vf> I<filter_graph>

I<filter_graph> is a description of the filter graph to apply to
the input video.
Use the option "-filters" to show all the available filters (including
also sources and sinks).


=back



=head2 Advanced options


=over 4


=item B<-pix_fmt> I<format>

Set pixel format.

=item B<-stats>

Show the stream duration, the codec parameters, the current position in
the stream and the audio/video synchronisation drift.

=item B<-debug>

Print specific debug info.

=item B<-bug>

Work around bugs.

=item B<-vismv>

Visualize motion vectors.

=item B<-fast>

Non-spec-compliant optimizations.

=item B<-genpts>

Generate pts.

=item B<-rtp_tcp>

Force RTP/TCP protocol usage instead of RTP/UDP. It is only meaningful
if you are streaming with the RTSP protocol.

=item B<-sync> I<type>

Set the master clock to audio (C<type=audio>), video
(C<type=video>) or external (C<type=ext>). Default is audio. The
master clock is used to control audio-video synchronization. Most media
players use audio as master clock, but in some cases (streaming or high
quality broadcast) it is necessary to change that. This option is mainly
used for debugging purposes.

=item B<-threads> I<count>

Set the thread count.

=item B<-ast> I<audio_stream_number>

Select the desired audio stream number, counting from 0. The number
refers to the list of all the input audio streams. If it is greater
than the number of audio streams minus one, then the last one is
selected, if it is negative the audio playback is disabled.

=item B<-vst> I<video_stream_number>

Select the desired video stream number, counting from 0. The number
refers to the list of all the input video streams. If it is greater
than the number of video streams minus one, then the last one is
selected, if it is negative the video playback is disabled.

=item B<-sst> I<subtitle_stream_number>

Select the desired subtitle stream number, counting from 0. The number
refers to the list of all the input subtitle streams. If it is greater
than the number of subtitle streams minus one, then the last one is
selected, if it is negative the subtitle rendering is disabled.

=item B<-autoexit>

Exit when video is done playing.

=item B<-exitonkeydown>

Exit if any key is pressed.

=item B<-exitonmousedown>

Exit if any mouse button is pressed.

=back



=head2 While playing



=over 4


=item B<q, ESC>

Quit.


=item B<f>

Toggle full screen.


=item B<p, SPC>

Pause.


=item B<a>

Cycle audio channel.


=item B<v>

Cycle video channel.


=item B<t>

Cycle subtitle channel.


=item B<w>

Show audio waves.


=item B<left/right>

Seek backward/forward 10 seconds.


=item B<down/up>

Seek backward/forward 1 minute.


=item B<mouse click>

Seek to percentage in file corresponding to fraction of width.


=back



=head1 INPUT DEVICES


Input devices are configured elements in FFmpeg which allow to access
the data coming from a multimedia device attached to your system.

When you configure your FFmpeg build, all the supported input devices
are enabled by default. You can list all available ones using the
configure option "--list-indevs".

You can disable all the input devices using the configure option
"--disable-indevs", and selectively enable an input device using the
option "--enable-indev=I<INDEV>", or you can disable a particular
input device using the option "--disable-indev=I<INDEV>".

The option "-formats" of the ff* tools will display the list of
supported input devices (amongst the demuxers).

A description of the currently available input devices follows.


=head2 alsa


ALSA (Advanced Linux Sound Architecture) input device.

To enable this input device during configuration you need libasound
installed on your system.

This device allows capturing from an ALSA device. The name of the
device to capture has to be an ALSA card identifier.

An ALSA identifier has the syntax:
	
	hw:<CARD>[,<DEV>[,<SUBDEV>]]


where the I<DEV> and I<SUBDEV> components are optional.

The three arguments (in order: I<CARD>,I<DEV>,I<SUBDEV>)
specify card number or identifier, device number and subdevice number
(-1 means any).

To see the list of cards currently recognized by your system check the
files F</proc/asound/cards> and F</proc/asound/devices>.

For example to capture with F<ffmpeg> from an ALSA device with
card id 0, you may run the command:
	
	ffmpeg -f alsa -i hw:0 alsaout.wav


For more information see:
E<lt>B<http://www.alsa-project.org/alsa-doc/alsa-lib/pcm.html>E<gt>


=head2 bktr


BSD video input device.


=head2 dv1394


Linux DV 1394 input device.


=head2 jack


JACK input device.

To enable this input device during configuration you need libjack
installed on your system.

A JACK input device creates one or more JACK writable clients, one for
each audio channel, with name I<client_name>:input_I<N>, where
I<client_name> is the name provided by the application, and I<N>
is a number which identifies the channel.
Each writable client will send the acquired data to the FFmpeg input
device.

Once you have created one or more JACK readable clients, you need to
connect them to one or more JACK writable clients.

To connect or disconnect JACK clients you can use the
F<jack_connect> and F<jack_disconnect> programs, or do it
through a graphical interface, for example with F<qjackctl>.

To list the JACK clients and their properties you can invoke the command
F<jack_lsp>.

Follows an example which shows how to capture a JACK readable client
with F<ffmpeg>.
	
	# Create a JACK writable client with name "ffmpeg".
	$ ffmpeg -f jack -i ffmpeg -y out.wav
	
	# Start the sample jack_metro readable client.
	$ jack_metro -b 120 -d 0.2 -f 4000
	
	# List the current JACK clients.
	$ jack_lsp -c
	system:capture_1
	system:capture_2
	system:playback_1
	system:playback_2
	ffmpeg:input_1
	metro:120_bpm
	
	# Connect metro to the ffmpeg writable client.
	$ jack_connect metro:120_bpm ffmpeg:input_1


For more information read:
E<lt>B<http://jackaudio.org/>E<gt>


=head2 libdc1394


IIDC1394 input device, based on libdc1394 and libraw1394.


=head2 oss


Open Sound System input device.

The filename to provide to the input device is the device node
representing the OSS input device, and is usually set to
F</dev/dsp>.

For example to grab from F</dev/dsp> using F<ffmpeg> use the
command:
	
	ffmpeg -f oss -i /dev/dsp /tmp/oss.wav


For more information about OSS see:
E<lt>B<http://manuals.opensound.com/usersguide/dsp.html>E<gt>


=head2 video4linux and video4linux2


Video4Linux and Video4Linux2 input video devices.

The name of the device to grab is a file device node, usually Linux
systems tend to automatically create such nodes when the device
(e.g. an USB webcam) is plugged into the system, and has a name of the
kind F</dev/videoI<N>>, where I<N> is a number associated to
the device.

Video4Linux and Video4Linux2 devices only support a limited set of
I<width>xI<height> sizes and framerates. You can check which are
supported for example with the command F<dov4l> for Video4Linux
devices and the command F<v4l-info> for Video4Linux2 devices.

If the size for the device is set to 0x0, the input device will
try to autodetect the size to use.

Video4Linux support is deprecated since Linux 2.6.30, and will be
dropped in later versions.

Follow some usage examples of the video4linux devices with the ff*
tools.
	
	# Grab and show the input of a video4linux device.
	ffplay -s 320x240 -f video4linux /dev/video0
	
	# Grab and show the input of a video4linux2 device, autoadjust size.
	ffplay -f video4linux2 /dev/video0
	
	# Grab and record the input of a video4linux2 device, autoadjust size.
	ffmpeg -f video4linux2 -i /dev/video0 out.mpeg



=head2 vfwcap


VfW (Video for Windows) capture input device.


=head2 x11grab


X11 video input device.

This device allows to capture a region of an X11 display.

The filename passed as input has the syntax:
	
	[<hostname>]:<display_number>.<screen_number>[+<x_offset>,<y_offset>]


I<hostname>:I<display_number>.I<screen_number> specifies the
X11 display name of the screen to grab from. I<hostname> can be
ommitted, and defaults to "localhost". The environment variable
B<DISPLAY> contains the default display name.

I<x_offset> and I<y_offset> specify the offsets of the grabbed
area with respect to the top-left border of the X11 screen. They
default to 0.

Check the X11 documentation (e.g. man X) for more detailed information.

Use the F<dpyinfo> program for getting basic information about the
properties of your X11 display (e.g. grep for "name" or "dimensions").

For example to grab from F<:0.0> using F<ffmpeg>:
	
	ffmpeg -f x11grab -r 25 -s cif -i :0.0 out.mpg
	
	# Grab at position 10,20.
	ffmpeg -f x11grab -25 -s cif -i :0.0+10,20 out.mpg



=head1 OUTPUT DEVICES


Output devices are configured elements in FFmpeg which allow to write
multimedia data to an output device attached to your system.

When you configure your FFmpeg build, all the supported output devices
are enabled by default. You can list all available ones using the
configure option "--list-outdevs".

You can disable all the output devices using the configure option
"--disable-outdevs", and selectively enable an output device using the
option "--enable-outdev=I<OUTDEV>", or you can disable a particular
input device using the option "--disable-outdev=I<OUTDEV>".

The option "-formats" of the ff* tools will display the list of
enabled output devices (amongst the muxers).

A description of the currently available output devices follows.


=head2 alsa


ALSA (Advanced Linux Sound Architecture) output device.


=head2 oss


OSS (Open Sound System) output device.


=head1 PROTOCOLS


Protocols are configured elements in FFmpeg which allow to access
resources which require the use of a particular protocol.

When you configure your FFmpeg build, all the supported protocols are
enabled by default. You can list all available ones using the
configure option "--list-protocols".

You can disable all the protocols using the configure option
"--disable-protocols", and selectively enable a protocol using the
option "--enable-protocol=I<PROTOCOL>", or you can disable a
particular protocol using the option
"--disable-protocol=I<PROTOCOL>".

The option "-protocols" of the ff* tools will display the list of
supported protocols.

A description of the currently available protocols follows.


=head2 concat


Physical concatenation protocol.

Allow to read and seek from many resource in sequence as if they were
a unique resource.

A URL accepted by this protocol has the syntax:
	
	concat:<URL1>|<URL2>|...|<URLN>


where I<URL1>, I<URL2>, ..., I<URLN> are the urls of the
resource to be concatenated, each one possibly specifying a distinct
protocol.

For example to read a sequence of files F<split1.mpeg>,
F<split2.mpeg>, F<split3.mpeg> with F<ffplay> use the
command:
	
	ffplay concat:split1.mpeg\|split2.mpeg\|split3.mpeg


Note that you may need to escape the character "|" which is special for
many shells.


=head2 file


File access protocol.

Allow to read from or read to a file.

For example to read from a file F<input.mpeg> with F<ffmpeg>
use the command:
	
	ffmpeg -i file:input.mpeg output.mpeg


The ff* tools default to the file protocol, that is a resource
specified with the name "FILE.mpeg" is interpreted as the URL
"file:FILE.mpeg".


=head2 gopher


Gopher protocol.


=head2 http


HTTP (Hyper Text Transfer Protocol).


=head2 mmst


MMS (Microsoft Media Server) protocol over TCP.


=head2 mmsh


MMS (Microsoft Media Server) protocol over HTTP.

The required syntax is:
	
	mmsh://<server>[:<port>][/<app>][/<playpath>]



=head2 md5


MD5 output protocol.

Computes the MD5 hash of the data to be written, and on close writes
this to the designated output or stdout if none is specified. It can
be used to test muxers without writing an actual file.

Some examples follow.
	
	# Write the MD5 hash of the encoded AVI file to the file output.avi.md5.
	ffmpeg -i input.flv -f avi -y md5:output.avi.md5
	
	# Write the MD5 hash of the encoded AVI file to stdout.
	ffmpeg -i input.flv -f avi -y md5:


Note that some formats (typically MOV) require the output protocol to
be seekable, so they will fail with the MD5 output protocol.


=head2 pipe


UNIX pipe access protocol.

Allow to read and write from UNIX pipes.

The accepted syntax is:
	
	pipe:[<number>]


I<number> is the number corresponding to the file descriptor of the
pipe (e.g. 0 for stdin, 1 for stdout, 2 for stderr).  If I<number>
is not specified, by default the stdout file descriptor will be used
for writing, stdin for reading.

For example to read from stdin with F<ffmpeg>:
	
	cat test.wav | ffmpeg -i pipe:0
	# ...this is the same as...
	cat test.wav | ffmpeg -i pipe:


For writing to stdout with F<ffmpeg>:
	
	ffmpeg -i test.wav -f avi pipe:1 | cat > test.avi
	# ...this is the same as...
	ffmpeg -i test.wav -f avi pipe: | cat > test.avi


Note that some formats (typically MOV), require the output protocol to
be seekable, so they will fail with the pipe output protocol.


=head2 rtmp


Real-Time Messaging Protocol.

The Real-Time Messaging Protocol (RTMP) is used for streaming multime‐
dia content across a TCP/IP network.

The required syntax is:
	
	rtmp://<server>[:<port>][/<app>][/<playpath>]


The accepted parameters are:

=over 4



=item B<server>

The address of the RTMP server.


=item B<port>

The number of the TCP port to use (by default is 1935).


=item B<app>

It is the name of the application to access. It usually corresponds to
the path where the application is installed on the RTMP server
(e.g. F</ondemand/>, F</flash/live/>, etc.).


=item B<playpath>

It is the path or name of the resource to play with reference to the
application specified in I<app>, may be prefixed by "mp4:".


=back


For example to read with F<ffplay> a multimedia resource named
"sample" from the application "vod" from an RTMP server "myserver":
	
	ffplay rtmp://myserver/vod/sample



=head2 rtmp, rtmpe, rtmps, rtmpt, rtmpte


Real-Time Messaging Protocol and its variants supported through
librtmp.

Requires the presence of the librtmp headers and library during
configuration. You need to explicitely configure the build with
"--enable-librtmp". If enabled this will replace the native RTMP
protocol.

This protocol provides most client functions and a few server
functions needed to support RTMP, RTMP tunneled in HTTP (RTMPT),
encrypted RTMP (RTMPE), RTMP over SSL/TLS (RTMPS) and tunneled
variants of these encrypted types (RTMPTE, RTMPTS).

The required syntax is:
	
	<rtmp_proto>://<server>[:<port>][/<app>][/<playpath>] <options>


where I<rtmp_proto> is one of the strings "rtmp", "rtmpt", "rtmpe",
"rtmps", "rtmpte", "rtmpts" corresponding to each RTMP variant, and
I<server>, I<port>, I<app> and I<playpath> have the same
meaning as specified for the RTMP native protocol.
I<options> contains a list of space-separated options of the form
I<key>=I<val>.

See the librtmp manual page (man 3 librtmp) for more information.

For example, to stream a file in real-time to an RTMP server using
F<ffmpeg>:
	
	ffmpeg -re -i myfile -f flv rtmp://myserver/live/mystream


To play the same stream using F<ffplay>:
	
	ffplay "rtmp://myserver/live/mystream live=1"



=head2 rtp


Real-Time Protocol.


=head2 tcp


Trasmission Control Protocol.


=head2 udp


User Datagram Protocol.


=head1 AUDIO FILTERS


When you configure your FFmpeg build, you can disable any of the
existing filters using --disable-filters.
The configure output will show the audio filters included in your
build.

Below is a description of the currently available audio filters.


=head2 anull


Pass the audio source unchanged to the output.


=head1 VIDEO FILTERS


When you configure your FFmpeg build, you can disable any of the
existing filters using --disable-filters.
The configure output will show the video filters included in your
build.

Below is a description of the currently available video filters.


=head2 crop


Crop the input video to I<x>:I<y>:I<width>:I<height>.

	
	./ffmpeg -i in.avi -vf "crop=0:0:0:240" out.avi


I<x> and I<y> specify the position of the top-left corner of the
output (non-cropped) area.

The default value of I<x> and I<y> is 0.

The I<width> and I<height> parameters specify the width and height
of the output (non-cropped) area.

A value of 0 is interpreted as the maximum possible size contained in
the area delimited by the top-left corner at position x:y.

For example the parameters:

	
	"crop=100:100:0:0"


will delimit the rectangle with the top-left corner placed at position
100:100 and the right-bottom corner corresponding to the right-bottom
corner of the input image.

The default value of I<width> and I<height> is 0.


=head2 fifo


Buffer input images and send them when they are requested.

This filter is mainly useful when auto-inserted by the libavfilter
framework.

The filter does not take parameters.


=head2 format


Convert the input video to one of the specified pixel formats.
Libavfilter will try to pick one that is supported for the input to
the next filter.

The filter accepts a list of pixel format names, separated by ``:'',
for example ``yuv420p:monow:rgb24''.

The following command:

	
	./ffmpeg -i in.avi -vf "format=yuv420p" out.avi


will convert the input video to the format ``yuv420p''.


=head2 hflip


Flip the input video horizontally.

For example to horizontally flip the video in input with
F<ffmpeg>:
	
	ffmpeg -i in.avi -vf "hflip" out.avi



=head2 noformat


Force libavfilter not to use any of the specified pixel formats for the
input to the next filter.

The filter accepts a list of pixel format names, separated by ``:'',
for example ``yuv420p:monow:rgb24''.

The following command:

	
	./ffmpeg -i in.avi -vf "noformat=yuv420p, vflip" out.avi


will make libavfilter use a format different from ``yuv420p'' for the
input to the vflip filter.


=head2 null


Pass the video source unchanged to the output.


=head2 ocv_smooth


Apply smooth transform using libopencv.

To enable this filter install libopencv library and headers and
configure FFmpeg with --enable-libopencv.

It accepts the following parameters:
I<type>:I<param1>:I<param2>:I<param3>:I<param4>.

I<type> is the type of smooth filter to apply, and can be one of
the following value: "blur", "blur_no_scale", "median", "gaussian",
"bilateral". The default value is "gaussian".

I<param1>, I<param2>, I<param3>, and I<param4> are
parameters whose meanings depend on smooth type. I<param1> and
I<param2> accept integer positive values or 0, I<param3> and
I<param4> accept float values.

The default value for I<param1> is 3, the default value for the
other parameters is 0.

These parameters corresponds to the parameters assigned to the
libopencv function C<cvSmooth>. Refer the official libopencv
documentation for the exact meaning of the parameters:
E<lt>B<http://opencv.willowgarage.com/documentation/c/image_filtering.html>E<gt>


=head2 pad


Add paddings to the input image, and places the original input at the
given coordinates I<x>, I<y>.

It accepts the following parameters:
I<width>:I<height>:I<x>:I<y>:I<color>.

Follows the description of the accepted parameters.


=over 4


=item B<width, height>


Specify the size of the output image with the paddings added. If the
value for I<width> or I<height> is 0, the corresponding input size
is used for the output.

The default value of I<width> and I<height> is 0.


=item B<x, y>


Specify the offsets where to place the input image in the padded area
with respect to the top/left border of the output image.

The default value of I<x> and I<y> is 0.


=item B<color>


Specify the color of the padded area, it can be the name of a color
(case insensitive match) or a 0xRRGGBB[AA] sequence.

The default value of I<color> is ``black''.


=back



=head2 pixdesctest


Pixel format descriptor test filter, mainly useful for internal
testing. The output video should be equal to the input video.

For example:
	
	format=monow, pixdesctest


can be used to test the monowhite pixel format descriptor definition.


=head2 scale


Scale the input video to I<width>:I<height> and/or convert the image format.

For example the command:

	
	./ffmpeg -i in.avi -vf "scale=200:100" out.avi


will scale the input video to a size of 200x100.

If the input image format is different from the format requested by
the next filter, the scale filter will convert the input to the
requested format.

If the value for I<width> or I<height> is 0, the respective input
size is used for the output.

If the value for I<width> or I<height> is -1, the scale filter will
use, for the respective output size, a value that maintains the aspect
ratio of the input image.

The default value of I<width> and I<height> is 0.


=head2 slicify


Pass the images of input video on to next video filter as multiple
slices.

	
	./ffmpeg -i in.avi -vf "slicify=32" out.avi


The filter accepts the slice height as parameter. If the parameter is
not specified it will use the default value of 16.

Adding this in the beginning of filter chains should make filtering
faster due to better use of the memory cache.


=head2 unsharp


Sharpen or blur the input video.

It accepts the following parameters:
I<luma_msize_x>:I<luma_msize_y>:I<luma_amount>:I<chroma_msize_x>:I<chroma_msize_y>:I<chroma_amount>

Negative values for the amount will blur the input video, while positive
values will sharpen. All parameters are optional and default to the
equivalent of the string '5:5:1.0:0:0:0.0'.


=over 4



=item B<luma_msize_x>

Set the luma matrix horizontal size. It can be an integer between 3
and 13, default value is 5.


=item B<luma_msize_y>

Set the luma matrix vertical size. It can be an integer between 3
and 13, default value is 5.


=item B<luma_amount>

Set the luma effect strength. It can be a float number between -2.0
and 5.0, default value is 1.0.


=item B<chroma_msize_x>

Set the chroma matrix horizontal size. It can be an integer between 3
and 13, default value is 0.


=item B<chroma_msize_y>

Set the chroma matrix vertical size. It can be an integer between 3
and 13, default value is 0.


=item B<luma_amount>

Set the chroma effect strength. It can be a float number between -2.0
and 5.0, default value is 0.0.


=back


	
	# Strong luma sharpen effect parameters
	unsharp=7:7:2.5
	
	# Strong blur of both luma and chroma parameters
	unsharp=7:7:-2:7:7:-2
	
	# Use the default values with B<ffmpeg>
	./ffmpeg -i in.avi -vf "unsharp" out.mp4



=head2 vflip


Flip the input video vertically.

	
	./ffmpeg -i in.avi -vf "vflip" out.avi



=head1 VIDEO SOURCES


Below is a description of the currently available video sources.


=head2 buffer


Buffer video frames, and make them available to the filter chain.

This source is mainly intended for a programmatic use, in particular
through the interface defined in F<libavfilter/vsrc_buffer.h>.

It accepts the following parameters:
I<width>:I<height>:I<pix_fmt_string>

All the parameters need to be explicitely defined.

Follows the list of the accepted parameters.


=over 4



=item B<width, height>

Specify the width and height of the buffered video frames.


=item B<pix_fmt_string>


A string representing the pixel format of the buffered video frames.
It may be a number corresponding to a pixel format, or a pixel format
name.


=back


For example:
	
	buffer=320:240:yuv410p


will instruct the source to accept video frames with size 320x240 and
with format "yuv410p". Since the pixel format with name "yuv410p"
corresponds to the number 6 (check the enum PixelFormat definition in
F<libavutil/pixfmt.h>), this example corresponds to:
	
	buffer=320:240:6



=head2 color


Provide an uniformly colored input.

It accepts the following parameters:
I<color>:I<frame_size>:I<frame_rate>

Follows the description of the accepted parameters.


=over 4



=item B<color>

Specify the color of the source. It can be the name of a color (case
insensitive match) or a 0xRRGGBB[AA] sequence, possibly followed by an
alpha specifier. The default value is "black".


=item B<frame_size>

Specify the size of the sourced video, it may be a string of the form
I<width>xI<heigth>, or the name of a size abbreviation. The
default value is "320x240".


=item B<frame_rate>

Specify the frame rate of the sourced video, as the number of frames
generated per second. It has to be a string in the format
I<frame_rate_num>/I<frame_rate_den>, an integer number, a float
number or a valid video frame rate abbreviation. The default value is
"25".


=back


For example the following graph description will generate a red source
with an opacity of 0.2, with size "qcif" and a frame rate of 10
frames per second, which will be overlayed over the source connected
to the pad with identifier "in".

	
	"color=red@0.2:qcif:10 [color]; [in][color] overlay [out]"



=head2 nullsrc


Null video source, never return images. It is mainly useful as a
template and to be employed in analysis / debugging tools.

It accepts as optional parameter a string of the form
I<width>:I<height>, where I<width> and I<height> specify the size of
the configured source.

The default values of I<width> and I<height> are respectively 352
and 288 (corresponding to the CIF size format).


=head1 VIDEO SINKS


Below is a description of the currently available video sinks.


=head2 nullsink


Null video sink, do absolutely nothing with the input video. It is
mainly useful as a template and to be employed in analysis / debugging
tools.


=head1 SEE ALSO

ffmpeg(1), ffprobe(1), ffserver(1) and the FFmpeg HTML documentation

=head1 AUTHORS

The FFmpeg developers

